routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;
// use App\Http\Controllers\produkController;
use App\Http\Controllers\productController;
use App\Http\Controllers\tokoProdukController;
use App\Http\Controllers\ulasanController;
use App\Http\Controllers\tokoulasanController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// toko
Route::get('/', fn () => redirect ()->route('beranda'));
// Route::get('/', [tokoProdukController::class, 'index'])->name('');
// Route::get('/', function () {
//     return view('beranda');
// });
// Route::get('/beranda', function () {
//     return view('beranda');
// });
Route::get('/beranda', [tokoProdukController::class, 'beranda'])->name('beranda');
Route::get('/product', [tokoProdukController::class, 'index'])->name('product');
Route::get('/Ulasan', [tokoulasanController::class, 'index'])->name('ulasan');
// Route::get('/product', function () {
// return view('product');
// });
// Route::resource('/product', productController::class);
Route::get('/ulasan', function () {
    return view('ulasan');
});

// admin
Route::get('/admin', fn () => redirect ()->route('login'));

Route::middleware([
    'auth:sanctum',
    config('jetstream.auth_session'),
    'verified'
])->group(function () {
    Route::get('/dashboard', function () {
        return view('home');
    })->name('dashboard');
});
Route::group(['middleware'=> 'auth'], function (){
//     // Route::get("/product/data", [productController::class, 'data'])->name('product.data');
    Route::get('/produk', function(){
        return view('produk.index');
    });
    Route::resource('/produk', productController::class);
    Route::resource('/ulasan', ulasanController::class);
});
// Route::resource('produk', produkController::class);
// Route::group(['middleware'=>'auth'], function(){
//     Route::get('/produk', [productController::class, 'index'])->name('produk');
//     Route::get('/produk/create', [productController::class, 'create'])->name('produk.create');
//     Route::post('/produk/store', [productController::class, 'store'])->name('produk.store');
//     Route::get('/produk/edit/', [productController::class, 'edit'])->name('produk.update');
//     // Route::put('/produk/update/',[productController::class, 'update'])->name('produk.update');
//     Route::delete('/produk/destroy/',[ productController::class, 'destroy'])->name('produk.destroy');
// });

app/Models/ulasan.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class ulasan extends Model
{
    use HasFactory;

    protected $fillable = [
        'profil_user', 'username', 'gambar_ulasan', 'ulasan'
    ];
    public $table = "ulasan";
}

app/Http/Controllers/ulasanController.php
<?php

namespace App\Http\Controllers;

use App\Models\ulasan;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;

class ulasanController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $ulasan= ulasan::latest()->paginate(10);
        return view ('ulasan.index', compact('ulasan'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view ('ulasan.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'profil_user'  => 'required|image|mimes:png,jpg,jpeg,jfif',
            'username' => 'required',
            'gambar_ulasan'=> 'required|image|mimes:png,jpg,jpeg,jfif',
            'ulasan'=> 'required'
        ]);

        $profil_user = $request->file('profil_user');
        $profil_user->storeAs('public/ulasan', $profil_user->hashName());
        $gambar_ulasan = $request->file('gambar_ulasan');
        $gambar_ulasan->storeAs('public/ulasan', $gambar_ulasan->hashName());

        $ulasan = ulasan::create([
            'profil_user'=> $profil_user->hashName(),
            'username'  => $request->username,
            'gambar_ulasan'=> $gambar_ulasan->hashName(),
            'ulasan' => $request->ulasan
        ]);
        if ($ulasan){
            return redirect()->route('ulasan.index')->with(['success' => 'Data Berhasil Disimpan!']);
        }else{
            return redirect()->route('ulasan.index')->with(['error' => 'Data gagal Disimpan!']);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(ulasan $ulasan)
    {
        return view ('ulasan.edit', compact('ulasan'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, ulasan $ulasan)
    {
        $this->validate($request, [
            'profil_user'  => 'required|image|mimes:png,jpg,jpeg,jfif',
            'username' => 'required',
            'gambar_ulasan'=> 'required|image|mimes:png,jpg,jpeg,jfif',
            'ulasan'=> 'required'
        ]);

       $ulasan= ulasan::findOrFail($ulasan->id);

        if ($request->file('profil_user') == "") {

            $produk->update([
            'username'  => $request->username,
            'ulasan' => $request->ulasan,
            ]);
        }else if($request->file('gambar_ulasan') == ""){
            $produk->update([
                'username'  => $request->username,
                'ulasan' => $request->ulasan,
                ]);
        }else{
            Storage:: disk('local')->delete('public/ulasan'.$produk->profil_user);
            Storage:: disk('local')->delete('public/ulasan'.$produk->gambar_ulasan);

            $profil_user = $request->file('profil_user');
            $profil_user->storeAs('public/ulasan', $profil_user->hashName());
            $gambar_ulasan = $request->file('gambar_ulasan');
            $gambar_ulasan->storeAs('public/ulasan', $gambar_ulasan->hashName());
            
            $ulasan->update([
            'profil_user'=> $profil_user->hashName(),
            'username'  => $request->username,
            'gambar_ulasan'=> $gambar_ulasan->hashName(),
            'ulasan' => $request->ulasan
            ]);
        }
        if ($produk){
            return redirect()->route('ulasan.index')->with(['success' => 'Data Berhasil Diupdate!']);
        }else{
            return redirect()->route('ulasan.index')->with(['error' => 'Data gagal Diupdate!']);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $ulasan= ulasan::findOrFail($id);
        Storage::disk('local')->delete('public/ulasan'.$ulasan->gambar_product);
        $ulasan->delete();
        
        if ($ulasan){
            return redirect()->route('ulasan.index')->with(['success' => 'Data Berhasil Dihapus!']);
        }else{
            return redirect()->route('ulasan.index')->with(['error' => 'Data gagal Dihapus!']);
        }
    }
}

resources/views/ulasan/create.blade.php
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Tambah Ulasan</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body style="background: lightgray">

    <div class="container mt-5 mb-5">
        <div class="row">
            <div class="col-md-12">
                <div class="card border-0 shadow rounded">
                    <div class="card-body">
                        <form action="{{ route('ulasan.store') }}" method="POST" enctype="multipart/form-data">

                            @csrf

                            <div class="form-group">
                                <label class="font-weight-bold">Profil User</label>
                                <input type="file" class="form-control @error('profil_user') is-invalid @enderror"
                                    name="profil_user">

                                <!-- error message untuk profil user-->
                                @error('profil_user')
                                    <div class="alert alert-danger mt-2">
                                        {{ $message }}
                                    </div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label class="font-weight-bold">Username</label>
                                <input type="text" class="form-control @error('username') is-invalid @enderror"
                                    name="username" value="{{ old('username') }}" placeholder="Masukkan Nama Produk">

                                <!-- error message untuk username -->
                                @error('username')
                                    <div class="alert alert-danger mt-2">
                                        {{ $message }}
                                    </div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label class="font-weight-bold">Gambar Ulasan</label>
                                <input type="file" class="form-control @error('gambar_ulasan') is-invalid @enderror"
                                    name="gambar_ulasan" value="{{ old('gambar_ulasan') }}"
                                    placeholder="Masukkan Gambar Produk">

                                <!-- error message untuk gambar_ulasan -->
                                @error('gambar_ulasan')
                                    <div class="alert alert-danger mt-2">
                                        {{ $message }}
                                    </div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label class="font-weight-bold">Ulasan</label>
                                <input type="text" class="form-control @error('ulasan') is-invalid @enderror"
                                    name="ulasan" value="{{ old('ulasan') }}" placeholder="Masukkan ulasan">

                                <!-- error message untuk ulasan -->
                                @error('ulasan')
                                    <div class="alert alert-danger mt-2">
                                        {{ $message }}
                                    </div>
                                @enderror
                            </div>

                            <button type="submit" class="btn btn-md btn-primary">SIMPAN</button>
                            <button type="reset" class="btn btn-md btn-warning">RESET</button>

                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <script src="https://cdn.ckeditor.com/4.13.1/standard/ckeditor.js"></script>
    <script>
        CKEDITOR.replace('content');
    </script>
</body>

</html>

resources/views/ulasan/edit.blade.php
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Edit Data Ulasan</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body style="background: lightgray">

    <div class="container mt-5 mb-5">
        <div class="row">
            <div class="col-md-12">
                <div class="card border-0 shadow rounded">
                    <div class="card-body">
                        <form action="{{ route('ulasan.update' . $ulasan->id) }}" method="POST"
                            enctype="multipart/form-data">
                            @csrf
                            @method('PUT')

                            <div class="form-group">
                                <label class="font-weight-bold">Gambar Ulasan</label>
                                <input type="file" class="form-control" name="gambar_ulasan">
                            </div>
                            <div class="form-group">
                                <label class="font-weight-bold">Username</label>
                                <input type="text" class="form-control @error('username') is-invalid @enderror"
                                    name="username" value="{{ old('username', $produk->username) }}"
                                    placeholder="Masukkan Nama Produk">

                                <!-- error message untuk username -->
                                @error('username')
                                    <div class="alert alert-danger mt-2">
                                        {{ $message }}
                                    </div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <label class="font-weight-bold">Gambar Ulasan</label>
                                <input type="text" class="form-control @error('gambar_ulasan') is-invalid @enderror"
                                    name="gambar_ulasan" value="{{ old('gambar_ulasan', $produk->gambar_ulasan) }}"
                                    placeholder="Masukkan Harga Produk">

                                <!-- error message untuk gambar_ulasan -->
                                @error('gambar_ulasan')
                                    <div class="alert alert-danger mt-2">
                                        {{ $message }}
                                    </div>
                                @enderror
                            </div>

                            <button type="submit" class="btn btn-md btn-primary">UPDATE</button>
                            <button type="reset" class="btn btn-md btn-warning">RESET</button>

                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <script src="https://cdn.ckeditor.com/4.13.1/standard/ckeditor.js"></script>
    <script>
        CKEDITOR.replace('content');
    </script>
</body>

</html>

resources/views/ulasan/index.blade.php
@extends('layout.template')

@section('title')
    Daftar ulasan
@endsection

@section('breadcrumb')
    @parent
    <li class="active">ulasan</li>
@endsection
@section('content')
    <div class="container mt-5">
        <div class="row">
            <div class="col-md-12">
                <div class="card border-0 shadow rounded">
                    <div class="card-body">
                        <a href="{{ route('ulasan.create') }}" class="btn btn-md btn-success mb-3">TAMBAH ULASAN</a>
                        <table class="table table-bordered">
                            <thead>
                                <tr>
                                    <th scope="col">NO</th>
                                    <th scope="col">Profil User</th>
                                    <th scope="col">username</th>
                                    <th scope="col">Gambar Ulasan</th>
                                    <th scope="col">Ulasan</th>
                                    <th scope="col">AKSI</th>
                                </tr>
                            </thead>
                            <tbody>

                                <?php $no = 1; ?>
                                @forelse ($ulasan as $u)
                                    <tr>
                                        <td>{{ $no++ }}</td>
                                        <td>
                                            <img src="{{ Storage::url('public/ulasan/') . $u->profil_user }}"
                                                class="rounded" style="width: 150px">
                                        <td>{{ $u->username }}</td>
                                        <td class="text-center">
                                            <img src="{{ Storage::url('public/ulasan/') . $u->gambar_ulasan }}"
                                                class="rounded" style="width: 150px">
                                        </td>
                                        <td>{{ $u->ulasan }}</td>
                                        <td class="text-center">
                                            <form onsubmit="return confirm('Apakah Anda Yakin ?');"
                                                action="{{ route('ulasan.destroy', $u->id) }}" method="POST">
                                                <a href="{{ route('ulasan.edit', $u->id) }}"
                                                    class="btn btn-sm btn-primary">EDIT</a>
                                                @csrf
                                                @method('DELETE')
                                                <button type="submit" class="btn btn-sm btn-danger">HAPUS</button>
                                            </form>
                                        </td>
                                    </tr>
                                @empty
                                    <div class="alert alert-danger">
                                        Data Post belum Tersedia.
                                    </div>
                                @endforelse
                            </tbody>
                        </table>
                        {{ $ulasan->links() }}
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <script src="//cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/toastr.min.js"></script>

    <script>
        //message with toastr
        @if (session()->has('success'))

            toastr.success('{{ session('success') }}', 'BERHASIL!');
        @elseif (session()->has('error'))

            toastr.error('{{ session('error') }}', 'GAGAL!');
        @endif
    </script>
@endsection